<?php
/*************************************************************

 File: acl.php
 Author: gernot
 Revision: 2.0.0
 Date: 2000/07/30

 This script showes and changes the Access LIST of a Mailbox

 Copyright 1999 Gernot Stocker <muecketb@sbox.tu-graz.ac.at>

 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 THIS PROGRAM IS AS IT IS! THE AUTHOR TAKES NO RESPONSABILTY ABOUT 
 EVENTUAL DEMAGES, SECURITS-HOLES OR ATTACKES, WHICH COULD BE ENABLED 
 BY THIS PROGRAM
 
 ***************************************************************/
 

/*
  To Show and Change Access LIST parameters
      needed variables:

	 $username =   Name of the owner of der mailbox
	 $folder   =   Mailboxfolder

*/

  require("config/config.php");

session_start();
if ($authenticated != 1) {
//    print "You need to be authenticated to access this file";
    Header("Location: $DEFAULT_URL");
    exit;
}



/*
  Initialising variables and arrays
*/
  require("lib/cyradm-php.lib");
  define("INCPATH", "includes");

  $folder=urldecode($folder);
  $username=urldecode($username);

  $folderorig=$folder;

  $folder= str_replace("/", ".",$folder);

  $rightlists=array( "l"     => "l",
               "r"     => "r",
	       "s"     => "s",
	       "w"     => "w",
	       "i"     => "i",
	       "p"     => "p",
	       "c"     => "c",
	       "d"     => "d",
	       "a"     => "a");

/*
   Get ACL of the specified folder from Server
*/
  $cconn = new cyradm($PHP_AUTH_USER, $PHP_AUTH_PW);
  $cconn->imap_login();
  $acl = $cconn->getacl("$folder");
  $cconn->imap_logout();


/*
   Compose the List of already set user ACL's
*/
   include(INCPATH."/acl_0_header.inc");
   if (count($acl)>0)
   { 
    while (list($key, $val) = each($acl)) 
       {                                                                                 
        print "<tr><td> $key </td>\n";
        print "<form action=\"action.php\" method=post>\n";
        while (list($right, $set) = each($rightlists)) 
            {                                                                                 
              print "<td>$right <input type=checkbox name=\"$right\"";            
              $pos=strstr($val,$set);
              if (strstr($val,$set)) { print "checked"; };
	      print " value=\"$set\"></td>\n";
 	    }
	reset($rightlists);
        include(INCPATH."/acl_1_userchange.inc");
       }
   }


/*
   Compose the form "Adding User to ACL List with specified ACR"
*/

   include(INCPATH."/acl_2_adduser_begin.inc");
   reset($rightlists);
   while (list($right, $set) = each($rightlists)) 
     { 
       print "<td> $right <input type=checkbox name=\"$right\" value=\"$set\"> </td>\n";
     }
   include(INCPATH."/acl_3_adduser_end.inc");


/*
   Compose the form "Deleting a User from the ACL of the folder"
*/
   $acl=$acl;		 
   reset($acl);
   while (list($key, $val) = each($acl)) 
     {                                                                                 
       echo  "<option value=\"",urlencode($key),"\">$key</option>\n ";
     }
   include(INCPATH."/acl_4_rmuser.inc");
   include(INCPATH."/footer.inc");








?>
