<?php
/*************************************************************

 File: action.php
 Author: gernot
 Revision: 2.0.0
 Date: 2000/11/08

 This script is the core of this Admin-Tool the hole actions are 
 executed from here

 Copyright 1999 Gernot Stocker <muecketb@sbox.tu-graz.ac.at>

 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 THIS PROGRAM IS AS IT IS! THE AUTHOR TAKES NO RESPONSABILTY ABOUT 
 EVENTUAL DEMAGES, SECURITS-HOLES OR ATTACKES, WHICH COULD BE ENABLED 
 BY THIS PROGRAM

 ***************************************************************/

/*
    The central part of the WebCyradm! From here actions will be called!
    needed variables:
      
           $username =   Name of the owner of der mailbox
	   $aktion =
	      
	     FOLDERFUNCTIONS:
		ask_del_folder  = security before deleting folder
				   [folder] which has to be deleted
		del_folder      = execution of deleting folder
				   [folder] which has to be deleted
		create_folder   = creation of folder
		ren_folder      = renaming the last sunfolder of the folder
		set_quota       = setting quotas for mailbox
		abort           = aborting action
		

	     ACL-FUNCTIONS: 
	      	ask_add_user    = 
		add_user        =
		set_acl         =
		del_acl         =
		new_acl         =


             CYRUS-Config:		    
		ask_configure   = load existing or default settings of the Cyrus Imap-Server 
		write_config    = writing specified configuration settings into a file 
	   
             ALIAS-FUNCTIONS:
		add             =
		delete          =
		change          =
		alias_change    =
		alias_delete    =
		
	     RENAMING:
	        ask_rename_mailbox	=
		ask_rename_mailbox	=
	   $cyrus_config_file
			    
*/



  require("lib/cyradm-php.lib");
  require("lib/cyrus-config.lib");
  require("config/config.php");
  if($use_aliases) { require("lib/aliases.lib"); } 

session_start();
if ($authenticated != 1) {
//    print "You need to be authenticated to access this file";
    Header("Location: $DEFAULT_URL");
    exit;
} 


  define("INCPATH", "includes");

  $username=urldecode($username);
  $folder=urldecode($folder);
  
//  define("IMAP_CONFIG_PATH", "/tmp/imapd.conf");

  $cimap = new cyradm($PHP_AUTH_USER, $PHP_AUTH_PW);
  $user_name_array=split("/",$username);
  if (strcmp($user_name_array[0],"user")==0)
        {$chin = substr($user_name_array[1], 0, 1);}
	else
	{$chin = substr($username, 0, 1);}


	
/* ####################################################
              FOLDER FUNCTIONS
   #################################################### */

  switch ($aktion) {

	  case "ask_del_folder":
              include(INCPATH."/header.inc");
	      include(INCPATH."/act_0_ask_for_del_folder.inc"); 
              include(INCPATH."/footer.inc");
	     break;


	  case "del_folder":
              include(INCPATH."/act_1_header_for_deleting_user.inc");
	      $init_char_arr=array();
              print "<center><hr><H1><blink>Removed FOLDER</blink>: $folder <br></H1><hr></center>";
	      $folder=str_replace("/","_x_knoel_x_",$folder);
	      $folder=trim($folder);
	      $folder=str_replace("_x_knoel_x_", ".", $folder);
	      $cimap->imap_login();
	      $cimap->deletemb($folder);
 	      $cimap->imap_logout();
	      $username=trim($username);
	      $folder=str_replace(".", "/", $folder);
	      print "<center>";
	      $init_char_arr=split("/",$username);
	      $initchar=$init_char_arr[1];
    	      if (strcmp($folder,$username)==0) 
	        { 
		    if($use_delete_system_call==true) {
		     /*
			Executing some system command after deleting a MAILUSER from CYRUS 
			e.g. deleting the aliasentry
    		    */
    		    $exec_result=array();
    		    unset($exec_result);
    		    $exec_return=-1;
    		    $end_array=sizeof($init_char_arr)-1;
    		    $system_command=$delete_system_call." ".$init_char_arr[$end_array];
    		    passthru (EscapeShellCmd($system_command), $exec_return);
    		    if ($exec_return == 0) {
		    echo "<center>Systemcall executed ($system_command) successfully!</center>";
	    	  }
    	          else {
		    echo "<center>Error while executing Systemcall ($system_command)!</center><hr>";
		  }
	        }
		 print "<a href=\"main.php?chin=$initchar[0]\"><img src=\"graphics/back.jpg\" border=\"0\"></a>";
		} 
	      else 
		{ 
		echo "<a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a>";
		}
              include(INCPATH."/footer.inc");
	      print "</center>";
	     break;


	  case "create_folder":
	      include(INCPATH."/header.inc");
	      if (strlen($newfolder)!=0)
	      {
  	        $folder = str_replace("/", "_x_knoel_x_", $folder);
	        $folder = trim($folder);
	        $folder = str_replace("_x_knoel_x_", ".", $folder).".".$newfolder;
	        $cimap->imap_login();
	        $cimap->createmb($folder);
	        $cimap->imap_logout();
	        print "<br><hr><center><H1>Creating Folder</H1>
                       <table border=1 cellpadding=5><tr><td>
		       <H3>Folder $folder created!</H3>
		       </td></tr></table>
		       </center><hr><br>";
	      }
	      else
	      { 
	        print "<br><hr><center><H1><blink>Error:</blink>New Folder not specified!!</H1></center><hr><br><br>";
	      }
              echo "<center><a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"> </a></center>";
              include(INCPATH."/footer.inc");
	     break;



	  case "ren_folder":
              include(INCPATH."/header.inc");
              $newfolder=trim($newfolder);
	      if (strcmp($newfolder,"")!=0)
               {
                $newfolderarray=split("/",$folder);
	         $folder = str_replace("/", "_x_knoel_x_", $folder);
	         $folder = trim($folder);
	         $folder = str_replace("_x_knoel_x_", ".", $folder);

                $renfolder=$newfolderarray[0];
		
                for ($i=1; $i < (count($newfolderarray)-1); $i++)
	         {
	          if ($newfolderarray[$i]) { $renfolder=$renfolder.".".$newfolderarray[$i];}
	         }

	        $renfolder=$renfolder.".".$newfolder;
	        $cimap->imap_login();
	        $cimap->renamemb($folder,$renfolder);
	        $cimap->imap_logout();
                include(INCPATH."/header.inc");
	        print "<center><br><hr>
		       <H1>RENAMING</H1>
		       <table border=1 cellpadding=7>
		       <tr><td><H3><b>Folder:</b>$folder</H3></td><td><H3><b>Renamed to:</b> $renfolder </H3></td><tr></table><hr>
		      ";
               }
	       else
	       {
	        print "<br><hr>
		        <H1><center>
			<blink>Error</blink>: New FOLDERNAME not specified!!
			<center></H1><hr><br>";
	       }
 	      echo "<a href=\"info.php?username=",urlencode($username),"\" target=\"info\" border=\"0\"><img src=\"graphics/back.jpg\" border=0></a></center>";
	      include(INCPATH."/footer.inc");
	     break;

          case "ask_rec_rename":
	      include(INCPATH."/header.inc");

              $newfolder=trim($newfolder);
	      if (strcmp($newfolder,"")!=0)
               {
	        $cimap->imap_login();
	        $folderarray=$cimap->EGetFolders($folder);
	        $cimap->imap_logout();
	        print "<center><hr><H1>RECURSIVE RENAME</H1><hr></center>
		       <table align=center border=0 cellpadding=5 cellspacing=5>
		       <tr><b>Do you really want renaming the following folders?</b><br></tr> 
		       ";
                $offset=split ("/",$folder);
	        $position=count($offset)-1;
	        for ($i=0; $i< count($folderarray); $i++){
                   $farray=split("/",$folderarray[$i]);
		   $farray[$position]=$newfolder;
		   $torename=$farray[0];
		   for ($k=1; $k< count($farray); $k++){
                     $torename="$torename"."/"."$farray[$k]";   
		     }
		   print "<tr><td>From: </td><td><b>$folderarray[$i]</b></td><td>To: </td><td><b>$torename</b></td></tr>";
	          }
	        echo "<tr><td></td><td><a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></td>
		       <td></td><td>
	               <a href=\"action.php?username=",urlencode($username),"&aktion=rec_rename&folder=",urlencode($folder),"&newfolder=",urlencode($newfolder),"\"><img src=\"graphics/ok.jpg\" border=\"0\"></a></td></tr></table>";
               }
	       else
	       {
	        echo "<br><hr>
		        <H1><center>
			<blink>Error</blink>: FOLDERNAME for renaming not specified!!
			<center></H1><hr><br>
 	                <a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	       }
	      include(INCPATH."/footer.inc");
	     break;
	  
          case "rec_rename":
	      include(INCPATH."/header.inc");
	      $cimap->imap_login();
	      $folderarray=$cimap->EGetFolders($folder);
              $offset=split ("/",$folder);
	      $position=count($offset)-1;
	      print "<hr><center><H1>RECURSIVE - RENAME</center></H1><hr>
	             <table border=0 align=center cellpadding=5 cellspacing=5>";
	      for ($i=0; $i< count($folderarray); $i++){
                 $farray=split("/",$folderarray[$i]);
		 $farray[$position]=$newfolder;
		 $torename=$farray[0];
		 for ($k=1; $k< count($farray); $k++){
                   $torename="$torename"."/"."$farray[$k]";   
		   }
		 print "<tr> <td><b>$folderarray[$i]</B></td> <td>renamed to</td> <td><B>$torename</b></td></tr>";
		 $folderarray[$i]=str_replace("/",".",$folderarray[$i]);
		 $torename=str_replace("/",".",$torename);		 
		 $cimap->renamemb($folderarray[$i],$torename); 
		}
	      $cimap->imap_logout();
	      print "</table>";
	      echo "<center><br><a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      include(INCPATH."/footer.inc");
	     break;

          case "ask_rec_delete":
   	        include(INCPATH."/header.inc");
                $newfolder=trim($newfolder);
	        $cimap->imap_login();
	        $folderarray=$cimap->EGetFolders($folder);
	        $cimap->imap_logout();
	        print "<center><hr><H1>RECURSIVE Delete</H1><hr></center>
		       <table align=center border=0 cellpadding=3 cellspacing=3>
		       <tr><b>Do you really want deleting the following folders?</b><br></tr> 
		       ";
	        for ($i=0; $i< count($folderarray); $i++){
		   print "<tr><td></td><td>$folderarray[$i]</td><td></td></tr>";
	          }
	        echo "<tr><td><a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></td>
		       <td></td><td><a href=\"action.php?username=",urlencode($username),"&aktion=rec_delete&folder=",urlencode($folder),"&newfolder=",urlencode($newfolder),"\"><img src=\"graphics/ok.jpg\" border=\"0\"></a></td></tr></table>";
 	        include(INCPATH."/footer.inc");
	     break;
	  
          case "rec_delete":
	      include(INCPATH."/header.inc");
	      $init_char=array();
	      $cimap->imap_login();
	      $folderarray=$cimap->EGetFolders($folder);
	      print "<hr><center><H1>RECURSIVE - DELETE</center></H1><hr>
	             <table border=0 align=center cellpadding=5 cellspacing=5>";
	      for ($i=(count($folderarray)-1); $i>= 0; $i--){
		 print "<tr> <td><b>$folderarray[$i]</B></td><td>deleted!</td></tr>";
		 $folderarray[$i]=str_replace("/",".",$folderarray[$i]);
		 $cimap->deletemb($folderarray[$i]); 
		}
	      $cimap->imap_logout();
	      print "</table>";
	      if (strcmp($username,$folder)==0)
	      {
	       $init_char_arr=split("/",$username);
	       $initchar=$init_char_arr[1];

	       if($use_delete_system_call==true) {
		     /*
			Executing some system command after deleting a MAILUSER from CYRUS 
			e.g. deleting the aliasentry
    		    */
    		    $exec_result=array();
    		    unset($exec_result);
    		    $exec_return=-1;
    		    $end_array=sizeof($init_char_arr)-1;
    		    $system_command=$delete_system_call." ".$init_char_arr[$end_array];
    		    passthru (EscapeShellCmd($system_command), $exec_return);
    		    if ($exec_return == 0) {
		    echo "Systemcall executed ($system_command) successfully!";
	    	  }
    	          else {
		    echo "Error while executing Systemcall ($system_command)!<hr>";
		  }
	        }
	       print "<center><br><a href=\"main.php?chin=$initchar[0]\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      }
	      else
	      {
	       echo "<center><br><a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      }
	      include(INCPATH."/footer.inc");
	     break;

	  case "set_quota":
              include(INCPATH."/header.inc");
              $testval=doubleval($newfolder);
	      if ($testval)
	      {
	        $cyr = new cyradm($PHP_AUTH_USER, $PHP_AUTH_PW);
                $cyr->imap_login();
		$imapusername=str_replace("/",".",$username);
                $quota = $cyr->getquota("$imapusername");
		$cyr->setmbquota("$imapusername", $newfolder);
                $cyr->imap_logout();

                print("<hr><center><H1>QUOTA</H1> <br>");
                print "<table border=1 cellpadding=7><tr><td> <H3>Used: $quota[used] kB <br></td><td><b>MAXIMUM</b> changed from: <b>$quota[qmax] kB</b> to: <b>$newfolder kB</b></td></tr></H3></table>";
	        echo "<br><hr><br><a href=\"info.php?username=",urlencode($username),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";

	      }
	      else
	      {
		echo "<center><br><hr><H1><blink>Error</blink>: QUOTAFIELD is empty/not specified!!</H1><hr><br><a href=\"info.php?username=",urlencode($username),"\"> <img src=\"graphics/back.jpg\" border=\"0\"> </a></center>";
	      };
              include(INCPATH."/footer.inc");
	     break;


	  case "ask_add_user":
	      $ccf = new config;
	      $quotaval=$ccf->get_config_tag($IMAP_CONFIG_PATH,"autocreatequota");
              include(INCPATH."/act_2.5_update_status.inc");
	      include(INCPATH."/act_3_ask_add_user_on_acl.inc");
              include(INCPATH."/footer.inc");
	  break;


	  case "add_user":
	     if (strcmp($username,"user.")!=0)
	      {
	       $init_char_arr=array();
	       $init_char_arr=split("\.",$username);	       
	       if(($use_add_system_call=="true")&&($syscall=="yes")) {
		     /*
			Executing some system command before adding a MAILUSER to CYRUS 
			e.g. adding the aliasentry
    		    */
                    include(INCPATH."/header.inc");
                    echo "<hr><center>";
    		    $exec_result=array();
    		    unset($exec_result);
    		    $exec_return=-1;
    		    $end_array=sizeof($init_char_arr)-1;
    		    $system_command=$add_system_call." ".(ltrim($init_char_arr[$end_array]));
    		    passthru (EscapeShellCmd($system_command), $exec_return);
    		    if ($exec_return == 0) {
		      echo "</center><hr><center>Systemcall executed <br>($system_command)<br> successfully!</center><hr>";
	              $cimap->imap_login();
	              $cimap->createmb("$username");
                      $username_array=split("\.",$username);
	              if (strcmp($quota,"")==0) { $quota=15000; };
	              $cimap->setmbquota("$username","$quota");
	              $cimap->imap_logout();
	              $infouser=str_replace(".","/",$username);
                      $bc=$username_array[1][0];

                      include(INCPATH."/act_4_add_user.inc");
	    	    }
    	            else {
                      include(INCPATH."/header.inc");
		      echo "</center><hr><center>Error while executing Systemcall <br>($system_command)<br>($username)($exec_return)!<hr>";
		      print "<a href=\"action.php?aktion=ask_add_user\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
                      include(INCPATH."/footer.inc");
		    }
	        }
	       else {
	              $cimap->imap_login();
	              $cimap->createmb("$username");
                      $username_array=split("\.",$username);
	              if (strcmp($quota,"")==0) { $quota=15000; };
	              $cimap->setmbquota("$username","$quota");
	              $cimap->imap_logout();
	              $infouser=str_replace(".","/",$username);
                      $bc=$username_array[1][0];
                      
                      include(INCPATH."/act_4_add_user.inc");
                      
		}	       
	      }
	     else
	      { 
               include(INCPATH."/header.inc");
		print "<center><br><hr><H1><blink>Error</blink>: USERNAME is empty/not specified!!</H1><hr><br><a href=\"action.php?aktion=ask_add_user\"> <img src=\"graphics/back.jpg\" border=\"0\"> </a></center>";
	      }
	       include(INCPATH."/footer.inc");

	  break;

/* ####################################################
                   ACL FUNCTIONS
   #################################################### */

	  case "set_acl":
              $folder_orig=urldecode($folder);
              $folder=str_replace("/", ".",$folder);
	      $new_acl="$l"."$r"."$s"."$w"."$i"."$p"."$c"."$d"."$a";

	      $cimap->imap_login();
	      if (strlen($new_acl)==0)
		 { $cimap->deleteacl($folder, $acluser); }
	      else
		 { $cimap->setacl($folder, $acluser, $new_acl); }
              $cimap->imap_logout();
	      
/*              $folder=str_replace(".", "/",$folder);
	      $folder_a=split("/",$folder,-1);
              $folder = "";
  	      for ($i=1; $i<count($folder_a); $i++)
	        {
		 if ($i==count($folder_a)-1)
		  { $folder=$folder.$folder_a[$i];
		  }
		  else
		  {
                  $folder=$folder.$folder_a[$i]."/";
		  };
		}*/
              include(INCPATH."/header.inc");
	      print "<center><hr><H1>SET AccessList</H1><hr>
                     <table border=0 cellpadding=5>
	              <tr><td><b>Owner of the Mailbox:</b></td><td>$username</td></tr> 
	              <tr><td><b>gives rights:</b></td><td>$new_acl</td></tr> 
	              <tr><td><b>on the folder:</b></td><td>$folder</td></tr> 
	              <tr><td><b>for the ACL-User:</b></td><td>$acluser</td></tr> 
		     </table><hr>"; 
	      echo "<br><a href=\"acl.php?username=",urlencode($username),"&folder=",urlencode($folder_orig),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
              include(INCPATH."/footer.inc");
	     break;
	      

	  case "del_acl":
              $folder_orig=urldecode($folder);
              $acluser=urldecode($acluser);
              include(INCPATH."/header.inc");
              $folder=str_replace("/", ".",$folder);
	      $cimap->imap_login();
	      $cimap->deleteacl($folder, $acluser);
	      $cimap->imap_logout();
              $folder=str_replace(".", "/", $folder);
	      
	      echo "<center><br><font face=\"Arial, Helvetica\" size=\"4\"><b>Delteting USER from Folder-AccessList</b></font><hr>
                     <table border=0 cellpadding=5>
	             <tr><td><b>The user:</b><td><td>$acluser</td></tr> 
	             <tr><td><b>is deleted from ACL of:</b><td><td>$folder</td></tr>
	             <tr><td><b>of the Owner:</b><td><td>$username</td></tr> 
		     </table><hr>\n
     	             <br><a href=\"acl.php?username=",urlencode($username),"&folder=",urlencode($folder),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	      include(INCPATH."/footer.inc");
	     break;


	  case "new_acl":
	      include(INCPATH."/header.inc");
	      $new_acl="$l"."$r"."$s"."$w"."$i"."$p"."$c"."$d"."$a";
	      if (strlen($acluser)==0 ||strlen($new_acl)==0 ) 
		{ echo "<center><hr><br><H1> <blink>ERROR</blink>: Username or AccessRights not set!!</H1><hr><br> 
			 <a href=\"acl.php?username=",urlencode($username),"&folder=",urlencode($folder),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>\n
			";
		}
	      else
		{ $imapfolder=str_replace("/", ".",$folder);    
	          $cimap->imap_login();
	          $cimap->setacl($imapfolder, $acluser, $new_acl);
	          $cimap->imap_logout();
                  include(INCPATH."/header.inc");
 		  echo "<center><br><font face=\"Arial, Helvetica\" size=\"4\"><b>Adding USER to Folder-AccessList</b></font><hr>
                         <table border=0 cellpadding=5>
			 <tr><td><b>The user:</b><td><td>$acluser</td></tr>
			 <tr><td><b>added to ACL of:</b><td><td>$folder</td></tr>
			 <tr><td><b>of:</b><td><td>$username</td></tr>
			 <tr><td><b>with rights:</b><td><td>$new_acl</td></tr>
		         <br>
			 </table><hr>
			 <a href=\"acl.php?username=",urlencode($username),"&folder=",urlencode($folder),"\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>\n";

		  }
                  include(INCPATH."/footer.inc");
	     break;

/* ####################################################
              Cyrus MB RENAME FUNCTION
   #################################################### */
	  case "ask_rename_mailbox":
              include(INCPATH."/renmb_1_update_status.inc");
	      include(INCPATH."/renmb_2_input_form.inc");
              include(INCPATH."/footer.inc");
	  break;

	  case "rename_mailbox":
              include(INCPATH."/header.inc");
	      echo "<center>";
	      $cimap->imap_login();
	      $repoldusername=str_replace(".","/",$oldusername);
	      $repnewusername=str_replace(".","/",$newusername);

	      $retold=$cimap->GetFolders($repoldusername);
	      $retnew=$cimap->GetFolders($repnewusername);
	      if (((count($retold))>0)&&((count($retnew))==0)&&
	          ((strcmp($oldusername,"user."))!=0)&&
		  ((strcmp($newusername,"user."))!=0))
		  {
                    if(($use_delete_system_call==true)&&("$syscall"=="yes")) {
		      /*
			Executing some system command before deleting a MAILUSER from CYRUS 
			e.g. deleting the aliasentry
    		      */
    		      $exec_result=array();
		      $init_char_arr=array();
    		      unset($exec_result);
		      unset($init_char_arr);
		      $init_char_arr=explode(".",$oldusername);
    		      $exec_return=-1;
    		      $end_array=sizeof($init_char_arr)-1;
    		      $system_command=$delete_system_call." ".$init_char_arr[$end_array];
    		      passthru (EscapeShellCmd($system_command), $exec_return);
    		      if ($exec_return == 0) {
		            echo "<center>DELETE Systemcall executed ($system_command) successfully!</center>";
	                    if(($use_add_system_call=="true")&&($syscall=="yes")) {
		            /*
			       Executing some system command before adding a MAILUSER to CYRUS 
			       e.g. adding the aliasentry
    		            */
                            echo "<hr><center>";
    		            $exec_result=array();
    		            unset($exec_result);
    		            $exec_return=-1;
		            unset($init_char_arr);
		            $init_char_arr=explode(".",$newusername);
    		            $end_array=sizeof($init_char_arr)-1;
    		            $system_command=$add_system_call." ".(ltrim($init_char_arr[$end_array]));
    		            passthru (EscapeShellCmd($system_command), $exec_return);
			    }			    
       		            $cimap->renameuser( $oldusername , $newusername );
	                    $cimap->imap_logout();
                	    $username_array=split("\.",$newusername);
    	        	    $infouser=str_replace(".","/",$newusername);
                	    $bc=$username_array[1][0];
                	    include(INCPATH."/act_4_add_user.inc");
			}
    	              else {
		         echo "<center>Error while executing Systemcall ($system_command)!</center><hr>";
  		         print "<a href=\"action.php?aktion=ask_rename_mailbox\"><img src=\"graphics/back.jpg\" border=\"0\"></a>";
                         include(INCPATH."/header.inc");
		        }
	             }
		     else {
	                    if(($use_add_system_call=="true")&&($syscall=="yes")) {
		            /*
			       Executing some system command before adding a MAILUSER to CYRUS 
			       e.g. adding the aliasentry
    		            */
                            echo "<hr><center>";
    		            $exec_result=array();
    		            unset($exec_result);
    		            $exec_return=-1;
		            unset($init_char_arr);
		            $init_char_arr=explode(".",$newusername);
    		            $end_array=sizeof($init_char_arr)-1;
    		            $system_command=$add_system_call." ".(ltrim($init_char_arr[$end_array]));
    		            passthru (EscapeShellCmd($system_command), $exec_return);
			    }       		            
			    $cimap->renameuser( $oldusername , $newusername );
	                    $cimap->imap_logout();
                	    $username_array=split("\.",$newusername);
    	        	    $infouser=str_replace(".","/",$newusername);
                	    $bc=$username_array[1][0];
                	    include(INCPATH."/act_4_add_user.inc");
		          }
		}
	      else
	        {
                 include(INCPATH."/renmb_1_update_status.inc");
		 print "<center><br><hr><H1><blink>Error</blink>: ONE of the USERNAME is empty/not specified or<br> destination does already exist!!
		        </H1><hr><br><a href=\"action.php?aktion=ask_rename_mailbox\"> <img src=\"graphics/back.jpg\" border=\"0\"> </a></center>";
                 include(INCPATH."/footer.inc");		
		}	      
	     break;


/* ####################################################
              Cyrus Config FUNCTIONS
   #################################################### */

          case "ask_configure":
               $conf = new config;
	       include(INCPATH."/con_0_ask_for_configuration.inc");
               $conf->get_config($IMAP_CONFIG_PATH);
	       include(INCPATH."/con_1_end_ofask_for_configuration.inc");
	      break;


          case "write_config":
	      if (file_exists($IMAP_CONFIG_PATH))
	         { 
		   $conff=fopen($IMAP_CONFIG_PATH, "w+");
		 }
	      if ($conff) {
               reset ($HTTP_POST_VARS);
               while (list ($key, $val) = each ($HTTP_POST_VARS)) {
		 if ((strcmp("$key","y")!=0)&&(strcmp("$key","x")!=0)) {
	          fwrite($conff,"$key: $val\n");
		 }
               }
	       fclose($conff);
               include(INCPATH."/header.inc");

               print "<center><hr>
	              <H1> Config-File written to ($IMAP_CONFIG_PATH)!</H1> 
		      <hr><br><table>";	       
               reset ($HTTP_POST_VARS);
               while (list ($key, $val) = each ($HTTP_POST_VARS)) {
		 if ((strcmp("$key","y")!=0)&&(strcmp("$key","x")!=0)) {
	          print "<tr> <td> $key:<td> <td>$val<td></tr>";
		 }
               }
               print "</table>
		     <br><hr><br>
		     <a href=\"action.php?aktion=ask_configure\"><img src=\"graphics/back.jpg\" border=\"0\"></a>
		     </center>";
	       include(INCPATH."/footer.inc");
	       }
	       else
	       {
                include(INCPATH."/header.inc");
		print " <hr>
		        <center>
		         Error while opening FILE ($IMAP_CONFIG_PATH)!<br>
			 The file must exist and the file permissions have to be ok for the apache-user
		        <hr>
		        <a href=\"action.php?aktion=ask_configure\"><img src=\"graphics/back.jpg\" border=\"0\"></a>
		        </center>";
	        include(INCPATH."/footer.inc");	       
	       }
              break;


/* ####################################################
              Alias Config FUNCTIONS
   #################################################### */
          case change:
               include(INCPATH."/header.inc");
	       print "<center><hr><H1>EDIT ALIASENTRY</H1><hr></center>
		       <b>Do you really want to edit the following ALIAS-Entry?</b><br> 
		       ";
	       echo "<center><table border=0 cellpadding=\"5\">
	       <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>         
	       <tr><td>from</td> <td>&nbsp</td><td>&nbsp</td><td>&nbsp;</td></tr>
	       <tr><td>&nbsp;</td> <td>$oldaliasname:</td><td>$oldmailboxname</td><td>&nbsp;</td></tr>
	       <tr><td>to</td> <td>&nbsp</td><td>&nbsp</td><td>&nbsp;</td></tr>
	       <tr><td>&nbsp;</td> <td>$aliasname:</td><td>$mailboxname</td><td>&nbsp;</td></tr>
	       <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>         
	       <tr><td><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></td>
		   <td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
	           <td><a href=\"action.php?aktion=alias_change&aliasname=$aliasname&mailboxname=$mailboxname&oldaliasname=$oldaliasname&oldmailboxname=$oldmailboxname\"><img src=\"graphics/ok.jpg\" border=\"0\"></a></td>
	       </tr></table></center>";	       
	       include(INCPATH."/footer.inc");
              break;

          case delete:
               include(INCPATH."/header.inc");
	       print "<center><hr><H1>DELETE ALIASENTRY</H1><hr></center>
		       <b>Do you really want to delete the following ALIAS-Entry?</b><br> 
		       ";
	       echo "<center><table border=0 cellpadding=\"5\">
	       <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>         
	       <tr><td>&nbsp;</td> <td>$oldaliasname:</td><td>$oldmailboxname</td><td>&nbsp;</td></tr>
	       <tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>         
	       <tr><td><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></td>
		   <td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
	           <td><a href=\"action.php?aktion=alias_delete&aliasname=$aliasname&mailboxname=$mailboxname&oldaliasname=$oldaliasname&oldmailboxname=$oldmailboxname\"><img src=\"graphics/ok.jpg\" border=\"0\"></a></td>
	       </tr></table></center>";	       
	       include(INCPATH."/footer.inc");
	      break;

          case alias_change:
	       $aliasname=trim($aliasname);
	       $mailboxname=trim($mailboxname);
	       if ( (( $aliasname )&&( $mailboxname ))||
	            (( $use_alias_system_call == true )&&($mailboxname)) 
		  ) 
	       {
                 $aliasc = new aliases($default_alias_file);
                 $result=$aliasc->alias_change($aliasname, $mailboxname, $oldaliasname, $oldmailboxname, $use_alias_system_call, $add_alias_system_call, $delete_alias_system_call);	       
                 if ($result == 0) {
                  include(INCPATH."/header.inc");
	          print "<center><hr><H1>ALIASENTRY ($aliasname: $mailboxname)CHANGED</H1><hr></center>
		      <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	          include(INCPATH."/footer.inc");
	         } else {
                  include(INCPATH."/header.inc");
	          print "<center><hr><H1>Error while changing ALIASENTRY <br>from ($oldaliasname: $oldmailboxname) <br>to ($aliasname: $mailboxname)</H1><hr></center>
		      <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	          include(INCPATH."/footer.inc");
	         }
	       }
	       else
	       {
                 include(INCPATH."/header.inc");
	         print "<center><hr><H1>Error while CHANGING ($aliasname: $mailboxname): NO DATA</H1><hr></center>
		        <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	         include(INCPATH."/footer.inc");
	       }
		 
              break;

          case alias_delete:
               $aliasc = new aliases($default_alias_file);
               $result=$aliasc->alias_delete( $oldaliasname, $oldmailboxname, $use_alias_system_call, $add_alias_system_call, $delete_alias_system_call);	       
               if ($result == 0) {
                include(INCPATH."/header.inc");
	        print "<center><hr><H1>ALIASENTRY ($oldaliasname: $oldmailboxname)DELETED</H1><hr></center>
		      <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	        include(INCPATH."/footer.inc");
	       } else {
                include(INCPATH."/header.inc");
	        print "<center><hr><H1>Error while Deleting ALIASENTRY ($oldaliasname: $oldmailboxname)</H1><hr></center>
		      <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	        include(INCPATH."/footer.inc");
	       }
              break;

          case add:
	       $aliasname=trim($aliasname);
	       $mailboxname=trim($mailboxname);
	       if ( (( $aliasname )&&( $mailboxname ))||
	            (( $use_alias_system_call == true )&&($mailboxname)) 
		  ) 
	       {
                $aliasc = new aliases($default_alias_file);
                $result=$aliasc->alias_add( $aliasname, $mailboxname, $use_alias_system_call, $add_alias_system_call, $delete_alias_system_call);
                if ($result == 0) {
                 include(INCPATH."/header.inc");
	         print "<center><hr><H1>ALIASENTRY ADDED SUCCESSFULLY</H1><hr></center>
		      <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	         include(INCPATH."/footer.inc");
	        } else {
                 include(INCPATH."/header.inc");
	         print "<center><hr><H1>Error while ADDING ALIASENTRY </H1><hr></center>
		      <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	         include(INCPATH."/footer.inc");
	        }
	       }
	       else
	       {
                 include(INCPATH."/header.inc");
	         print "<center><hr><H1>Error while ADDING ALIASENTRY ($aliasname: $mailboxname): NO DATA</H1><hr></center>
		        <br><center><a href=\"alias.php\"><img src=\"graphics/back.jpg\" border=\"0\"></a></center>";
	         include(INCPATH."/footer.inc");
	       }
              break;
	      

	  }  

?>
