<?php
/*************************************************************

 File: browse.php
 Author: gernot
 Revision: 1.0.0
 Date: 1999/05/30

  This script gives you an overview about mailboxfolder 

 Copyright 1999 Gernot Stocker <muecketb@sbox.tu-graz.ac.at>

 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 THIS PROGRAM IS AS IT IS! THE AUTHOR TAKES NO RESPONSABILTY ABOUT 
 EVENTUAL DEMAGES, SECURITS-HOLES OR ATTACKES, WHICH COULD BE ENABLED 
 BY THIS PROGRAM
 
 ***************************************************************/

/*
   It gives you information about a specified mailbox and the possibility to 
   add/delete/rename folders, change their ACL's, and to set quotas!
      needed variables:
      
         $username  =   Name of the owner of der mailbox
*/

  require("config/config.php");

session_start();
if ($authenticated != 1) {
//    print "You need to be authenticated to access this file";
    Header("Location: $DEFAULT_URL");
    exit;
} 

/*
  Initialising variables and arrays
*/
   require("lib/cyradm-php.lib");
   if($use_aliases) { require("lib/aliases.lib"); }
 
 
   define("INCPATH", "includes");
//   echo "<br><H1>USERNAME: ($username) BROWSECHAR: $bc</H1><br>";

  

   include(INCPATH."/header.inc");

   $username=urldecode($username);

   $infouser=urldecode($infouser);
   $username_array=split("/",$username);
   $imap_user=str_replace("/",".",$username);




/* 
   Get the alias (if $use_ailiases = true) 
 */   

   $buff = split("/",$username);
   $myuser = $buff[1];
   if ($myuser == "") { $myuser = '&nbsp;'; }

   if ($use_aliases) {
      $aliasc = new aliases($default_alias_file);
      $myalias = $aliasc->get_alias($myuser);
      if ($myalias != "" ) {
        $myalias = $myalias."@".$default_domain;
      }
      else {
        $myalias = '&nbsp;';
      }
   }




/*
  Conecting to the Imap Server an get quotas and subfolderlists
*/
  include(INCPATH."/inf_0.5_quota.inc");

  $imapc = new cyradm($PHP_AUTH_USER, $PHP_AUTH_PW);

  $imapc->imap_login();
  $imap_user_array=split(".",$imap_user);
  
  $user_array=$imapc->EGetFolders($username); 

  if (count($username_array)>1){
    $quotapfad=$username_array[0].".".$username_array[1];
   }
   else
   {
    $quotapfad=$username_array[0];
   }

  $quota_info=$imapc->getquota($quotapfad);
  $imapc->imap_logout();


  include(INCPATH."/inf_0_quotaoutput.inc");
  $imapc->GenerateFolderList($user_array,$username);



/*
   Generating list of subfolders for adding/deleteing/renameing imap-folders 
*/
   include(INCPATH."/inf_1_preparing_work_form.inc");
   
	      
   if ($user_array)
     { 
       for ($l=0; $l<count($user_array); $l++)
          {
            echo "<option value=",
	    urlencode($user_array[$l]),
	    ">/$user_array[$l] </option>\n ";
          }
     }
   include(INCPATH."/inf_2_completing_work_form.inc");
   include(INCPATH."/footer.inc");

?>
	